HYPER-V(4)

NAME
hv_storvsc - Hyper-V Storage Virtual Service Consumer

SYNOPSIS
To compile this driver into the kernel, place the following lines in the system kernel configuration file:

device hyperv

DESCRIPTION
The hv_storvsc driver implements the virtual store device for FreeBSD guest partitions running on Hyper-V. FreeBSD guest partitions running on Hyper-V do not have direct access to storage devices attached to the Hyper-V server. Although a FreeBSD guest can access storage devices using Hyper-V's full emulation mode, the performance in this mode tends to be unsatisfactory.

To counter the above issues, the hv_storvsc driver implements a storage Virtual Service Consumer (VSC) that relays storage requests from the guest partition to the storage Virtual Service Provider (VSP) hosted in the root partition using the high performance data exchange infrastructure provided by hv_vmbus(4) driver. The VSP in the root partition then forwards the storage related requests to the physical storage device.

This driver functions by presenting a SCSI HBA interface to the Common Access Method (CAM) layer. CAM control blocks (CCBs) are converted into VSCSI protocol messages which are delivered to the root partition VSP over the Hyper-V VMBus.

SEE ALSO
hv_ata_pci_disengage(4), hv_netvsc(4), hv_utils(4), hv_vmbus(4)

HISTORY
Support for hv_storvsc first appeared in FreeBSD 10.0. The driver was developed through a joint effort between Citrix Incorporated, Microsoft Corporation, and Network Appliance Incorporated.

AUTHORS
-nosplit FreeBSD support for hv_storvsc was first added by Microsoft BSD Integration Services Team <bsdic@microsoft.com>.